#!/bin/env bash

set -e

REGISTRY_HOST={{ coremedia_build.docker_registry.host }}
{% if coremedia_build.docker_registry.username is defined %}
REGISTRY_USER={{ coremedia_build.docker_registry.username }}
{% else %}
REGISTRY_USER=
{% endif %}
{% if coremedia_build.docker_registry.password is defined %}
REGISTRY_PASSWORD={{ coremedia_build.docker_registry.password }}
{% else %}
REGISTRY_PASSWORD=
{% endif %}

COREMEDIA_VERSION=${COREMEDIA_VERSION:-{{ coremedia_build_workspace_version }}}

{% raw %}

delete_untagged_images() {

  # deleting untagged images
  docker image \
    prune --filter="dangling=true" --force
}

delete_images_with_none_tag() {

  mapfile -t images < <(docker images --format "table {{.ID}} {{.Repository}} {{.Tag}}" | tail -n +2 | sort)

  for i in "${images[@]}"
  do
    id=$(echo "${i}" | cut -d' ' -f1)
    [ $(echo "${id}" | wc -c) -ne 13 ] && continue

    tag=$(echo "${i}" | cut -d' ' -f3)

    [ "${tag}" = "<none>" ] && docker rmi --force ${id}

  done
}

retag_images() {

  echo "retag docker images"

  dest=()

  mapfile -t images < <(docker images --format "table {{.ID}} {{.Repository}} {{.Tag}}" | tail -n +2 | sort)

  for i in "${images[@]}"
  do
    id=$(echo "${i}" | cut -d' ' -f1)
    [ $(echo "${id}" | wc -c) -ne 13 ] && continue

    img=$(echo "${i}" | cut -d' ' -f2)
    tag=$(echo "${i}" | cut -d' ' -f3)

    [[ $img =~ ^${REGISTRY_HOST}.* ]] && continue

    if [[ ! $img =~ ^coremedia/.*$ ]] && [[ ! $img =~ ${REGISTRY_HOST} ]]
    then
      DEST="${REGISTRY_HOST}/coremedia/${img}:${tag}"
    else
      DEST="${REGISTRY_HOST}/${img}:${tag}"
    fi

    dest+=("${img}:${tag}","${DEST}")

    if [[ ${DEST} =~ .*coremedia.*:latest$ ]]
    then
      DEST="$(echo "${DEST}" | sed "s|latest|${COREMEDIA_VERSION}|")"
      dest+=("${img}:${tag}","${DEST}")
    fi

    #echo "${img} -> ${DEST}"
    #docker tag ${img}:${tag} ${DEST}
  done

  for row in ${dest[@]}
  do
    source="${row%%,*}"
    destination="${row##*,}"

    # echo -e " - ${source}\t\t -> ${destination}"
    docker tag ${source} ${destination}
  done
}

login_into_registry() {

  if [ ! -z "${REGISTRY_USER}" ] && [ ! -z "${REGISTRY_PASSWORD}" ]
  then
    docker login \
      --username ${REGISTRY_USER} \
      --password ${REGISTRY_PASSWORD} \
      ${REGISTRY_HOST}
  fi
}

push_images() {

  echo "push images into registry ${REGISTRY_HOST}"

  mapfile -t images < <(docker images \
    --quiet \
    --format "table {{.ID}} {{.Repository}}:{{.Tag}}" \
    ${REGISTRY_HOST}/coremedia/* | \
    egrep -v ".*:<none>$" | \
    tail -n +2)

  for i in "${images[@]}"
  do
    id=$(echo "${i}" | cut -d' ' -f1)
    [ $(echo "${id}" | wc -c) -ne 13 ] && continue

    img=$(echo "${i}" | cut -d' ' -f2)

    docker push ${img} > /dev/null
  done
}


run() {

  delete_untagged_images
  retag_images
  login_into_registry
  push_images
}

run

exit 0

{% endraw %}
